Index: /pjproject/branches/projects/2.0-dev/pjmedia/build/pjmedia.vcproj
===================================================================
--- /pjproject/branches/projects/2.0-dev/pjmedia/build/pjmedia.vcproj	(revision 3419)
+++ /pjproject/branches/projects/2.0-dev/pjmedia/build/pjmedia.vcproj	(revision 3420)
@@ -4313,5 +4313,5 @@
 			</File>
 			<File
-				RelativePath="..\src\pjmedia\session.c"
+				RelativePath="..\src\pjmedia\silencedet.c"
 				>
 				<FileConfiguration
@@ -4371,5 +4371,9 @@
 			</File>
 			<File
-				RelativePath="..\src\pjmedia\silencedet.c"
+				RelativePath="..\src\pjmedia\sound_legacy.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\pjmedia\sound_port.c"
 				>
 				<FileConfiguration
@@ -4429,9 +4433,5 @@
 			</File>
 			<File
-				RelativePath="..\src\pjmedia\sound_legacy.c"
-				>
-			</File>
-			<File
-				RelativePath="..\src\pjmedia\sound_port.c"
+				RelativePath="..\src\pjmedia\splitcomb.c"
 				>
 				<FileConfiguration
@@ -4491,5 +4491,9 @@
 			</File>
 			<File
-				RelativePath="..\src\pjmedia\splitcomb.c"
+				RelativePath="..\src\pjmedia\stereo_port.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\pjmedia\stream.c"
 				>
 				<FileConfiguration
@@ -4549,9 +4553,9 @@
 			</File>
 			<File
-				RelativePath="..\src\pjmedia\stereo_port.c"
-				>
-			</File>
-			<File
-				RelativePath="..\src\pjmedia\stream.c"
+				RelativePath="..\src\pjmedia\stream_common.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\pjmedia\tonegen.c"
 				>
 				<FileConfiguration
@@ -4611,5 +4615,21 @@
 			</File>
 			<File
-				RelativePath="..\src\pjmedia\tonegen.c"
+				RelativePath="..\src\pjmedia\transport_adapter_sample.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\pjmedia\transport_ice.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\pjmedia\transport_loop.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\pjmedia\transport_srtp.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\pjmedia\transport_udp.c"
 				>
 				<FileConfiguration
@@ -4669,79 +4689,9 @@
 			</File>
 			<File
-				RelativePath="..\src\pjmedia\transport_adapter_sample.c"
-				>
-			</File>
-			<File
-				RelativePath="..\src\pjmedia\transport_ice.c"
-				>
-			</File>
-			<File
-				RelativePath="..\src\pjmedia\transport_loop.c"
-				>
-			</File>
-			<File
-				RelativePath="..\src\pjmedia\transport_srtp.c"
-				>
-			</File>
-			<File
-				RelativePath="..\src\pjmedia\transport_udp.c"
-				>
-				<FileConfiguration
-					Name="Release|Win32"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-						AdditionalIncludeDirectories=""
-						PreprocessorDefinitions=""
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Debug|Win32"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-						AdditionalIncludeDirectories=""
-						PreprocessorDefinitions=""
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Debug-Static|Win32"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-						AdditionalIncludeDirectories=""
-						PreprocessorDefinitions=""
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Release-Dynamic|Win32"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-						AdditionalIncludeDirectories=""
-						PreprocessorDefinitions=""
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Debug-Dynamic|Win32"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-						AdditionalIncludeDirectories=""
-						PreprocessorDefinitions=""
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Release-Static|Win32"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-						AdditionalIncludeDirectories=""
-						PreprocessorDefinitions=""
-					/>
-				</FileConfiguration>
-			</File>
-			<File
 				RelativePath="..\src\pjmedia\vid_codec.c"
+				>
+			</File>
+			<File
+				RelativePath="..\src\pjmedia\vid_stream.c"
 				>
 			</File>
@@ -5120,8 +5070,4 @@
 			</File>
 			<File
-				RelativePath="..\include\pjmedia\session.h"
-				>
-			</File>
-			<File
 				RelativePath="..\include\pjmedia\silencedet.h"
 				>
@@ -5148,4 +5094,8 @@
 			</File>
 			<File
+				RelativePath="..\include\pjmedia\stream_common.h"
+				>
+			</File>
+			<File
 				RelativePath="..\include\pjmedia\tonegen.h"
 				>
@@ -5181,4 +5131,8 @@
 			<File
 				RelativePath="..\include\pjmedia\vid_codec.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\pjmedia\vid_stream.h"
 				>
 			</File>
Index: /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia-videodev/videodev.h
===================================================================
--- /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia-videodev/videodev.h	(revision 3419)
+++ /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia-videodev/videodev.h	(revision 3420)
@@ -79,6 +79,6 @@
  *
  * Once video stream is running, application can also retrieve or set some
- * specific video capability, by using #pjmedia_vid_stream_get_cap() and
- * #pjmedia_vid_stream_set_cap() and specifying the desired capability. The
+ * specific video capability, by using #pjmedia_vid_dev_stream_get_cap() and
+ * #pjmedia_vid_dev_stream_set_cap() and specifying the desired capability. The
  * value of the capability is specified as pointer, and application needs to
  * supply the pointer with the correct value, according to the documentation
@@ -155,6 +155,6 @@
 
 
-/** Forward declaration for pjmedia_vid_stream */
-typedef struct pjmedia_vid_stream pjmedia_vid_stream;
+/** Forward declaration for pjmedia_vid_dev_stream */
+typedef struct pjmedia_vid_dev_stream pjmedia_vid_dev_stream;
 
 typedef enum pjmedia_event_type
@@ -188,5 +188,5 @@
     *                      stream to stop
     */
-    pj_status_t (*capture_cb)(pjmedia_vid_stream *stream,
+    pj_status_t (*capture_cb)(pjmedia_vid_dev_stream *stream,
 		              void *user_data,
                               pjmedia_frame *frame);
@@ -211,5 +211,5 @@
     *                      stream to stop
     */
-    pj_status_t (*render_cb)(pjmedia_vid_stream *stream,
+    pj_status_t (*render_cb)(pjmedia_vid_dev_stream *stream,
 			     void *user_data,
                              pjmedia_frame *frame);
@@ -227,5 +227,5 @@
     *                      video stream will ignore the particular event.
     */
-    pj_status_t (*on_event_cb)(pjmedia_vid_stream *stream,
+    pj_status_t (*on_event_cb)(pjmedia_vid_dev_stream *stream,
 			       void *user_data,
                                pjmedia_vid_event *event);
@@ -477,8 +477,9 @@
  *                      error code.
  */
-PJ_DECL(pj_status_t) pjmedia_vid_stream_create(const pjmedia_vid_param *param,
-                                               const pjmedia_vid_cb *cb,
-                                               void *user_data,
-                                               pjmedia_vid_stream **p_strm);
+PJ_DECL(pj_status_t) pjmedia_vid_dev_stream_create(
+					    const pjmedia_vid_param *param,
+					    const pjmedia_vid_cb *cb,
+					    void *user_data,
+					    pjmedia_vid_dev_stream **p_strm);
 
 /**
@@ -492,6 +493,7 @@
  *                  error code.
  */
-PJ_DECL(pj_status_t) pjmedia_vid_stream_get_param(pjmedia_vid_stream *strm,
-                                                  pjmedia_vid_param *param);
+PJ_DECL(pj_status_t) pjmedia_vid_dev_stream_get_param(
+					    pjmedia_vid_dev_stream *strm,
+                                            pjmedia_vid_param *param);
 
 /**
@@ -508,7 +510,8 @@
  *                  error code.
  */
-PJ_DECL(pj_status_t) pjmedia_vid_stream_get_cap(pjmedia_vid_stream *strm,
-                                                pjmedia_vid_dev_cap cap,
-                                                void *value);
+PJ_DECL(pj_status_t) pjmedia_vid_dev_stream_get_cap(
+					    pjmedia_vid_dev_stream *strm,
+					    pjmedia_vid_dev_cap cap,
+                                            void *value);
 
 /**
@@ -523,7 +526,8 @@
  *                  error code.
  */
-PJ_DECL(pj_status_t) pjmedia_vid_stream_set_cap(pjmedia_vid_stream *strm,
-                                                pjmedia_vid_dev_cap cap,
-                                                const void *value);
+PJ_DECL(pj_status_t) pjmedia_vid_dev_stream_set_cap(
+					    pjmedia_vid_dev_stream *strm,
+					    pjmedia_vid_dev_cap cap,
+					    const void *value);
 
 /**
@@ -535,12 +539,15 @@
  *                  error code.
  */
-PJ_DECL(pj_status_t) pjmedia_vid_stream_start(pjmedia_vid_stream *strm);
+PJ_DECL(pj_status_t) pjmedia_vid_dev_stream_start(
+					    pjmedia_vid_dev_stream *strm);
 
 /* Get/put frame API for passive stream */
-PJ_DECL(pj_status_t) pjmedia_vid_stream_get_frame(pjmedia_vid_stream *strm,
-                                                  pjmedia_frame *frame);
-
-PJ_DECL(pj_status_t) pjmedia_vid_stream_put_frame(pjmedia_vid_stream *strm,
-                                                  const pjmedia_frame *frame);
+PJ_DECL(pj_status_t) pjmedia_vid_dev_stream_get_frame(
+					    pjmedia_vid_dev_stream *strm,
+                                            pjmedia_frame *frame);
+
+PJ_DECL(pj_status_t) pjmedia_vid_dev_stream_put_frame(
+					    pjmedia_vid_dev_stream *strm,
+                                            const pjmedia_frame *frame);
 
 /**
@@ -552,5 +559,6 @@
  *                  error code.
  */
-PJ_DECL(pj_status_t) pjmedia_vid_stream_stop(pjmedia_vid_stream *strm);
+PJ_DECL(pj_status_t) pjmedia_vid_dev_stream_stop(
+					    pjmedia_vid_dev_stream *strm);
 
 /**
@@ -562,5 +570,6 @@
  *                  error code.
  */
-PJ_DECL(pj_status_t) pjmedia_vid_stream_destroy(pjmedia_vid_stream *strm);
+PJ_DECL(pj_status_t) pjmedia_vid_dev_stream_destroy(
+					    pjmedia_vid_dev_stream *strm);
 
 
Index: /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia-videodev/videodev_imp.h
===================================================================
--- /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia-videodev/videodev_imp.h	(revision 3419)
+++ /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia-videodev/videodev_imp.h	(revision 3420)
@@ -84,5 +84,5 @@
     /**
      * Open the video device and create video stream. See
-     * #pjmedia_vid_stream_create()
+     * #pjmedia_vid_dev_stream_create()
      */
     pj_status_t (*create_stream)(pjmedia_vid_dev_factory *f,
@@ -90,5 +90,5 @@
 				 const pjmedia_vid_cb *cb,
 				 void *user_data,
-				 pjmedia_vid_stream **p_vid_strm);
+				 pjmedia_vid_dev_stream **p_vid_strm);
 
 } pjmedia_vid_dev_factory_op;
@@ -114,54 +114,54 @@
  * Video stream operations.
  */
-typedef struct pjmedia_vid_stream_op
+typedef struct pjmedia_vid_dev_stream_op
 {
     /**
-     * See #pjmedia_vid_stream_get_param()
+     * See #pjmedia_vid_dev_stream_get_param()
      */
-    pj_status_t (*get_param)(pjmedia_vid_stream *strm,
+    pj_status_t (*get_param)(pjmedia_vid_dev_stream *strm,
 			     pjmedia_vid_param *param);
 
     /**
-     * See #pjmedia_vid_stream_get_cap()
+     * See #pjmedia_vid_dev_stream_get_cap()
      */
-    pj_status_t (*get_cap)(pjmedia_vid_stream *strm,
+    pj_status_t (*get_cap)(pjmedia_vid_dev_stream *strm,
 			   pjmedia_vid_dev_cap cap,
 			   void *value);
 
     /**
-     * See #pjmedia_vid_stream_set_cap()
+     * See #pjmedia_vid_dev_stream_set_cap()
      */
-    pj_status_t (*set_cap)(pjmedia_vid_stream *strm,
+    pj_status_t (*set_cap)(pjmedia_vid_dev_stream *strm,
 			   pjmedia_vid_dev_cap cap,
 			   const void *value);
 
     /**
-     * See #pjmedia_vid_stream_start()
+     * See #pjmedia_vid_dev_stream_start()
      */
-    pj_status_t (*start)(pjmedia_vid_stream *strm);
+    pj_status_t (*start)(pjmedia_vid_dev_stream *strm);
 
     /**
-     * See #pjmedia_vid_stream_get_frame()
+     * See #pjmedia_vid_dev_stream_get_frame()
      */
-    pj_status_t (*get_frame)(pjmedia_vid_stream *strm,
+    pj_status_t (*get_frame)(pjmedia_vid_dev_stream *strm,
                              pjmedia_frame *frame);
 
     /**
-     * See #pjmedia_vid_stream_put_frame()
+     * See #pjmedia_vid_dev_stream_put_frame()
      */
-    pj_status_t (*put_frame)(pjmedia_vid_stream *strm,
+    pj_status_t (*put_frame)(pjmedia_vid_dev_stream *strm,
                              const pjmedia_frame *frame);
 
     /**
-     * See #pjmedia_vid_stream_stop().
+     * See #pjmedia_vid_dev_stream_stop().
      */
-    pj_status_t (*stop)(pjmedia_vid_stream *strm);
+    pj_status_t (*stop)(pjmedia_vid_dev_stream *strm);
 
     /**
-     * See #pjmedia_vid_stream_destroy().
+     * See #pjmedia_vid_dev_stream_destroy().
      */
-    pj_status_t (*destroy)(pjmedia_vid_stream *strm);
+    pj_status_t (*destroy)(pjmedia_vid_dev_stream *strm);
 
-} pjmedia_vid_stream_op;
+} pjmedia_vid_dev_stream_op;
 
 
@@ -169,5 +169,5 @@
  * This structure describes the video device stream.
  */
-struct pjmedia_vid_stream
+struct pjmedia_vid_dev_stream
 {
     /** Internal data to be initialized by video subsystem */
@@ -178,5 +178,5 @@
 
     /** Operations */
-    pjmedia_vid_stream_op *op;
+    pjmedia_vid_dev_stream_op *op;
 };
 
Index: /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia.h
===================================================================
--- /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia.h	(revision 3419)
+++ /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia.h	(revision 3420)
@@ -53,5 +53,5 @@
 #include <pjmedia/sdp.h>
 #include <pjmedia/sdp_neg.h>
-#include <pjmedia/session.h>
+//#include <pjmedia/session.h>
 #include <pjmedia/silencedet.h>
 #include <pjmedia/sound.h>
@@ -60,4 +60,5 @@
 #include <pjmedia/stereo.h>
 #include <pjmedia/stream.h>
+#include <pjmedia/stream_common.h>
 #include <pjmedia/tonegen.h>
 #include <pjmedia/transport.h>
@@ -69,4 +70,5 @@
 #include <pjmedia/videoport.h>
 #include <pjmedia/vid_codec.h>
+#include <pjmedia/vid_stream.h>
 #include <pjmedia/wav_playlist.h>
 #include <pjmedia/wav_port.h>
Index: /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia/config.h
===================================================================
--- /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia/config.h	(revision 3419)
+++ /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia/config.h	(revision 3420)
@@ -980,4 +980,13 @@
 
 /**
+ * Maximum video frame size.
+ * Default: 16kB
+ */
+#ifndef PJMEDIA_MAX_VIDEO_FRAME_SIZE			
+#  define PJMEDIA_MAX_VIDEO_FRAME_SIZE			(1<<14)
+#endif
+
+
+/**
  * Specify the maximum duration (in ms) for resynchronization. When a media
  * is late to another media it is supposed to be synchronized to, it is
Index: /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia/jbuf.h
===================================================================
--- /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia/jbuf.h	(revision 3419)
+++ /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia/jbuf.h	(revision 3420)
@@ -69,5 +69,5 @@
  * This structure describes jitter buffer state.
  */
-struct pjmedia_jb_state
+typedef struct pjmedia_jb_state
 {
     /* Setting */
@@ -90,11 +90,5 @@
     unsigned	discard;	    /**< Number of discarded frames.	    */
     unsigned	empty;		    /**< Number of empty on GET events.	    */
-};
-
-
-/**
- * @see pjmedia_jb_state
- */
-typedef struct pjmedia_jb_state pjmedia_jb_state;
+} pjmedia_jb_state;
 
 
@@ -181,4 +175,17 @@
 
 /**
+ * Enable/disable the jitter buffer drift detection and handling mechanism.
+ * The default behavior is enabled.
+ *
+ * @param jb		The jitter buffer
+ * @param enable	Set to PJ_TRUE to enable or PJ_FALSE to disable.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjmedia_jbuf_enable_discard(pjmedia_jbuf *jb,
+						 pj_bool_t enable);
+
+
+/**
  * Destroy jitter buffer instance.
  *
@@ -244,4 +251,30 @@
 				       pj_bool_t *discarded);
 
+/**
+ * Put a frame to the jitter buffer. If the frame can be accepted (based
+ * on the sequence number), the jitter buffer will copy the frame and put
+ * it in the appropriate position in the buffer.
+ *
+ * Application MUST manage it's own synchronization when multiple threads
+ * are accessing the jitter buffer at the same time.
+ *
+ * @param jb		The jitter buffer.
+ * @param frame		Pointer to frame buffer to be stored in the jitter
+ *			buffer.
+ * @param size		The frame size.
+ * @param bit_info	Bit precise info of the frame, e.g: a frame may not 
+ *			exactly start and end at the octet boundary, so this
+ *			field may be used for specifying start & end bit offset.
+ * @param frame_seq	The frame sequence number.
+ * @param frame_ts	The frame timestamp.
+ * @param discarded	Flag whether the frame is discarded by jitter buffer.
+ */
+PJ_DECL(void) pjmedia_jbuf_put_frame3( pjmedia_jbuf *jb, 
+				       const void *frame, 
+				       pj_size_t size, 
+				       pj_uint32_t bit_info,
+				       int frame_seq,
+				       pj_uint32_t frame_ts,
+				       pj_bool_t *discarded);
 /**
  * Get a frame from the jitter buffer. The jitter buffer will return the
@@ -294,4 +327,23 @@
 
 
+PJ_DECL(void) pjmedia_jbuf_get_frame3(pjmedia_jbuf *jb, 
+				      void *frame, 
+				      pj_size_t *size, 
+				      char *p_frm_type,
+				      pj_uint32_t *bit_info,
+				      pj_uint32_t *ts);
+
+PJ_DECL(void) pjmedia_jbuf_peek_frame(pjmedia_jbuf *jb,
+				      unsigned idx,
+				      const void **frame, 
+				      pj_size_t *size, 
+				      char *p_frm_type,
+				      pj_uint32_t *bit_info,
+				      pj_uint32_t *ts);
+
+PJ_DECL(unsigned) pjmedia_jbuf_remove_frame(pjmedia_jbuf *jb, 
+					    unsigned frame_cnt);
+
+
 /**
  * Get jitter buffer current state/settings.
Index: /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia/stream.h
===================================================================
--- /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia/stream.h	(revision 3419)
+++ /pjproject/branches/projects/2.0-dev/pjmedia/include/pjmedia/stream.h	(revision 3420)
@@ -144,4 +144,28 @@
 
 
+/**
+ * This function will initialize the stream info based on information
+ * in both SDP session descriptors for the specified stream index. 
+ * The remaining information will be taken from default codec parameters. 
+ * If socket info array is specified, the socket will be copied to the 
+ * session info as well.
+ *
+ * @param si		Stream info structure to be initialized.
+ * @param pool		Pool to allocate memory.
+ * @param endpt		PJMEDIA endpoint instance.
+ * @param local		Local SDP session descriptor.
+ * @param remote	Remote SDP session descriptor.
+ * @param stream_idx	Media stream index in the session descriptor.
+ *
+ * @return		PJ_SUCCESS if stream info is successfully initialized.
+ */
+PJ_DECL(pj_status_t)
+pjmedia_stream_info_from_sdp( pjmedia_stream_info *si,
+			      pj_pool_t *pool,
+			      pjmedia_endpt *endpt,
+			      const pjmedia_sdp_session *local,
+			      const pjmedia_sdp_session *remote,
+			      unsigned stream_idx);
+
 
 /**
